## libyang3 3.4.2+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -59,14 +59,14 @@
 
 # set version of the project
 set(LIBYANG_MAJOR_VERSION 3)
-set(LIBYANG_MINOR_VERSION 1)
-set(LIBYANG_MICRO_VERSION 0)
+set(LIBYANG_MINOR_VERSION 4)
+set(LIBYANG_MICRO_VERSION 2)
 set(LIBYANG_VERSION ${LIBYANG_MAJOR_VERSION}.${LIBYANG_MINOR_VERSION}.${LIBYANG_MICRO_VERSION})
 
 # set version of the library
 set(LIBYANG_MAJOR_SOVERSION 3)
-set(LIBYANG_MINOR_SOVERSION 2)
-set(LIBYANG_MICRO_SOVERSION 0)
+set(LIBYANG_MINOR_SOVERSION 4)
+set(LIBYANG_MICRO_SOVERSION 2)
 set(LIBYANG_SOVERSION_FULL ${LIBYANG_MAJOR_SOVERSION}.${LIBYANG_MINOR_SOVERSION}.${LIBYANG_MICRO_SOVERSION})
 set(LIBYANG_SOVERSION ${LIBYANG_MAJOR_SOVERSION})
 
@@ -106,7 +106,8 @@
     src/plugins_types/date_and_time.c
     src/plugins_types/hex_string.c
     src/plugins_types/xpath1.0.c
-    src/plugins_types/node_instanceid.c)
+    src/plugins_types/node_instanceid.c
+    src/plugins_types/time_period.c)
 
 set(libsrc
     src/ly_common.c
