=== debian/changelog ===
libyang3 (3.4.2+dfsg-1) sid; urgency=medium

  * Uploading to sid.
  * Merging upstream version 3.4.2+dfsg.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Tue, 17 Sep 2024 05:00:18 +0200
